<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FlightSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FlightSupplier extends AbstractStructArrayBase
{
    /**
     * The FlightSupplier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FlightSupplier[]
     */
    public $FlightSupplier;
    /**
     * Constructor method for ArrayOfJP_FlightSupplier
     * @uses ArrayOfJP_FlightSupplier::setFlightSupplier()
     * @param \StructType\JP_FlightSupplier[] $flightSupplier
     */
    public function __construct(array $flightSupplier = array())
    {
        $this
            ->setFlightSupplier($flightSupplier);
    }
    /**
     * Get FlightSupplier value
     * @return \StructType\JP_FlightSupplier[]|null
     */
    public function getFlightSupplier()
    {
        return $this->FlightSupplier;
    }
    /**
     * Set FlightSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplier[] $flightSupplier
     * @return \ArrayType\ArrayOfJP_FlightSupplier
     */
    public function setFlightSupplier(array $flightSupplier = array())
    {
        foreach ($flightSupplier as $arrayOfJP_FlightSupplierFlightSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FlightSupplierFlightSupplierItem instanceof \StructType\JP_FlightSupplier) {
                throw new \InvalidArgumentException(sprintf('The FlightSupplier property can only contain items of \StructType\JP_FlightSupplier, "%s" given', is_object($arrayOfJP_FlightSupplierFlightSupplierItem) ? get_class($arrayOfJP_FlightSupplierFlightSupplierItem) : gettype($arrayOfJP_FlightSupplierFlightSupplierItem)), __LINE__);
            }
        }
        $this->FlightSupplier = $flightSupplier;
        return $this;
    }
    /**
     * Add item to FlightSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FlightSupplier $item
     * @return \ArrayType\ArrayOfJP_FlightSupplier
     */
    public function addToFlightSupplier(\StructType\JP_FlightSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FlightSupplier) {
            throw new \InvalidArgumentException(sprintf('The FlightSupplier property can only contain items of \StructType\JP_FlightSupplier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FlightSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FlightSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FlightSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FlightSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FlightSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FlightSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightSupplier
     */
    public function getAttributeName()
    {
        return 'FlightSupplier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_FlightSupplier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
